#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int convert_any_to_dec (unsigned long& number /* out */,
	 const char* string /* in */, const unsigned power /* in */)
{
	unsigned long p = 1;
    number = 0;

	for (int i = strlen (string) - 1; i >= 0; i--) {
    	unsigned digit;
		if (string [i] >= '0' && string [i] <= '9')
			digit = string [i] - '0';
		else
			if (string [i] >= 'a' && string [i] <= 'z')
            	digit = string [i] - 'a' + 10;
            else
				if (string [i] >= 'A' && string [i] <= 'Z')
					digit = string [i] - 'A' + 10;
                else
                	return -1;

        if (digit >= power)
        	return -1;

    	number += digit * p;
        p *= power;
    }
    return 0;
}

void convert_dec_to_any (char* string /* out */,
	const unsigned long number /* in */, const unsigned power /* in */)
{
	char* ptr = string;
	unsigned long n = number;

    if (n == 0) {
    	*(ptr++) = '0';
        *ptr = '\0';
    } else {
		while (n != 0) {
			unsigned long quotient = n / power;
			unsigned long reminder = n % power;
    	   	n = quotient;
        	*(ptr++) = reminder > 9 ? reminder + 'a' - 10 : reminder + '0';
		}
    	*ptr = '\0';
	    strrev (string);
    }
}

int main (int argc, char* argv[])
{
    if (argc == 4) {
    	int from_power = atoi (argv [1]);
        int to_power = atoi (argv [2]);
        if (from_power > 1 && from_power < 37) {
        	if (to_power > 1 && to_power < 37) {
		    	unsigned long n;
    		    if (!convert_any_to_dec (n, argv [3], from_power)) {
        	        char buf [100];
	    			convert_dec_to_any (buf, n, to_power);
                	printf ("%s(%d) = %lu(10) = %s(%d)\n",
						argv [3], from_power, n, buf, to_power);
	        		return 0;
				} else
              		printf ("Invalid parameter <number>.\n");
	        } else
    	    	printf ("Invalid parameter <to_power>.\n");
        } else
        	printf ("Invalid parameter <from_power>.\n");
	} else
		printf ("Convert 1.0.0.1 Copyright (c) 2000 Studentware\n"
	    	"Usage: convert <from_power> <to_power> <number>\n"
			"  <from_power> - 2..36\n"
			"  <to_power>   - 2..36\n"
			"  <number>     - positive number, digit(s): '0'..'9','a'..'z'\n");
	return 1;
}
